package de.pheerai.rcdbquery.dataMappings.classification

import de.pheerai.rcdbquery.dataMappings.internal.RcdbParamOption
import de.pheerai.rcdbquery.dataMappings.internal.StringGeneratable

public enum class Classification(
    override val prettyName: String,
    override val fullName: String,
    override val paramValue: Long
) : RcdbParamOption<Long> {
    ROLLER_COASTER("Roller Coaster", 277),
    POWERED_COASTER("Powered Coaster", 278),
    MOUNTAIN_COASTER("Mountain Coaster", 279),
    ;

    constructor(name: String, paramValue: Long) : this(name, name, paramValue)

    public companion object: StringGeneratable<Classification> {
        override fun of(input: String): Classification? = values().find { it.fullName == input }
        override val paramKey: String = "cs"
    }
}
