package de.pheerai.rcdbquery.dataMappings.internal

public abstract class MultiParamBuilder<out U : Any, T : RcdbParamOption<U>> {
    private val paramList: MutableList<T> = mutableListOf()

    public open fun add(param: T): MultiParamBuilder<U, T> {
        paramList.add(param)
        return this
    }

    protected open fun addAll(items: Array<T>): MultiParamBuilder<U, T> {
        paramList.addAll(items)
        return this
    }

    protected open fun addAll(items: Collection<T>): MultiParamBuilder<U, T> {
        paramList.addAll(items)
        return this
    }

    public fun build(): List<T> = paramList.toList()

    public abstract operator fun T.invoke(): MultiParamBuilder<U, T>
}
