package de.pheerai.rcdbquery.dataMappings.layout

import de.pheerai.rcdbquery.dataMappings.internal.RcdbParamOption
import de.pheerai.rcdbquery.dataMappings.internal.StringGeneratable

public enum class Layout(
    override val prettyName: String,
    override val fullName: String,
    override val paramValue: Long
) : RcdbParamOption<Long> {
    BIG_APPLE("Big Apple / Wacky Worm", 282),
    CIRCLE_DIP("Circle Dip", 36),
    CIRCULAR_GRAVIY_RAILWAY("Circular Gravity Railway", 269),
    CYCLONE("Cyclone", 96),
    DOUBLE_FIGURE_EIGHT("Double Figure Eight", 123),
    DOUBLE_OUT_AND_BACK("Double Out and Back", 121),
    FIGURE_EIGHT("Figure Eight", 102),
    JUNGLE_MOUSE("Jungle Mouse", 305),
    L_SHAPED_OUT_AND_BACK("L-Shaped Out and Back", 254),
    MITE_MOUSE("Mite Mouse", 206),
    OUT_AND_BACK("Out and Back", 99),
    OVAL("Oval", 124),
    SHUTTLE_LOOP("Shuttle Loop", 97),
    SINGLE_HELIX_CENTER("Single Helix (center)", 142),
    SINGLE_HELIX_LEFT("Single Helix (left)", 141),
    SINGLE_HELIX_REAR("Single Helix (rear)", 83),
    SINGLE_HELIX_RIGHT("Single Helix (right)", 139),
    TERRAIN("Terrain", 125),
    TRIANGLE("Triangle", 90),
    TRIPLE_OUT_AND_BACK("Triple Out and Back", 301),
    TWIN_HELIX("Twin Helix", 140),
    TWISTER("Twister", 122),
    U_SHUTTLE("U Shuttle", 81),
    WILD_MOUSE("Wild Mouse", 95),
    ZYKLON("Zyklon / Galaxy", 294)
    ;

    constructor(name: String, paramValue: Long) : this(name, name, paramValue)

    public companion object : StringGeneratable<Layout> {
        override val paramKey: String = "lo"

        override fun of(input: String): Layout? = values().find { input == it.fullName }
    }
}
