package de.pheerai.rcdbquery.dataMappings.order

import de.pheerai.rcdbquery.dataMappings.internal.MultiParamBuilder

public class OrderBuilder : MultiParamBuilder<Long, Order>() {
    override fun add(param: Order): OrderBuilder {
        super.add(param)
        return this
    }

    override fun addAll(items: Array<Order>): OrderBuilder {
        super.addAll(items)
        return this
    }

    override fun addAll(items: Collection<Order>): OrderBuilder {
        super.addAll(items)
        return this
    }

    override operator fun Order.invoke(): OrderBuilder = add(this)
    public fun allRelevant(): OrderBuilder = this.addAll(Order.values().filter { it.relevantForAll })
}
